/* moonshot-settings.c generated by valac 0.10.4, the Vala compiler
 * generated from moonshot-settings.vala, do not modify */

/*
 * Copyright (c) 2011-2016, JANET(UK)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of JANET(UK) nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define TYPE_MOONSHOT_LOGGER (moonshot_logger_get_type ())
#define MOONSHOT_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MOONSHOT_LOGGER, MoonshotLogger))
#define MOONSHOT_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MOONSHOT_LOGGER, MoonshotLoggerClass))
#define IS_MOONSHOT_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MOONSHOT_LOGGER))
#define IS_MOONSHOT_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MOONSHOT_LOGGER))
#define MOONSHOT_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MOONSHOT_LOGGER, MoonshotLoggerClass))

typedef struct _MoonshotLogger MoonshotLogger;
typedef struct _MoonshotLoggerClass MoonshotLoggerClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_key_file_free0(var) ((var == NULL) ? NULL : (var = (g_key_file_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



GType moonshot_logger_get_type (void) G_GNUC_CONST;
MoonshotLogger* logger (void);
MoonshotLogger* get_logger (const char* name);
#define KEY_FILE_NAME "moonshot-ui.config"
GKeyFile* get_keyfile (void);
void moonshot_logger_trace (MoonshotLogger* self, const char* message, GError* e);
void save_keyfile (GKeyFile* key_file);
void moonshot_logger_error (MoonshotLogger* self, const char* message, GError* e);
void set_bool_setting (const char* group_name, const char* key_name, gboolean value, GKeyFile* key_file);
gboolean get_bool_setting (const char* group_name, const char* key_name, gboolean _default_, GKeyFile* key_file);
void moonshot_logger_info (MoonshotLogger* self, const char* message, GError* e);
void set_string_setting (const char* group_name, const char* key_name, const char* value, GKeyFile* key_file);
char* get_string_setting (const char* group_name, const char* key_name, const char* _default_, GKeyFile* key_file);



#line 36 "moonshot-settings.vala"
MoonshotLogger* logger (void) {
#line 78 "moonshot-settings.c"
	MoonshotLogger* result = NULL;
	result = get_logger ("MoonshotSettings");
#line 38 "moonshot-settings.vala"
	return result;
#line 83 "moonshot-settings.c"
}


#line 43 "moonshot-settings.vala"
GKeyFile* get_keyfile (void) {
#line 89 "moonshot-settings.c"
	GKeyFile* result = NULL;
	GKeyFile* key_file;
	char* config_dir;
	MoonshotLogger* _tmp0_;
	char* _tmp1_;
	GFile* dir;
	GFile* _tmp2_;
	char* _tmp3_;
	char* path;
	GError * _inner_error_ = NULL;
#line 45 "moonshot-settings.vala"
	key_file = g_key_file_new ();
#line 46 "moonshot-settings.vala"
	config_dir = g_strdup (g_get_user_config_dir ());
#line 47 "moonshot-settings.vala"
	moonshot_logger_trace (_tmp0_ = logger (), _tmp1_ = g_strconcat ("get_keyfile: config_dir=", config_dir, NULL), NULL);
#line 106 "moonshot-settings.c"
	_g_free0 (_tmp1_);
	_g_object_unref0 (_tmp0_);
#line 49 "moonshot-settings.vala"
	dir = g_file_new_for_path (config_dir);
#line 50 "moonshot-settings.vala"
	path = (_tmp3_ = g_file_get_path (_tmp2_ = g_file_get_child (dir, KEY_FILE_NAME)), _g_object_unref0 (_tmp2_), _tmp3_);
#line 113 "moonshot-settings.c"
	{
		gboolean _tmp4_;
#line 53 "moonshot-settings.vala"
		_tmp4_ = g_key_file_load_from_file (key_file, path, G_KEY_FILE_NONE, &_inner_error_);
#line 118 "moonshot-settings.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch10_g_file_error;
			}
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch10_g_key_file_error;
			}
			_g_free0 (path);
			_g_object_unref0 (dir);
			_g_free0 (config_dir);
			_g_key_file_free0 (key_file);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
#line 53 "moonshot-settings.vala"
		if (_tmp4_) {
#line 136 "moonshot-settings.c"
			MoonshotLogger* _tmp5_;
#line 54 "moonshot-settings.vala"
			moonshot_logger_trace (_tmp5_ = logger (), "get_keyfile: load_from_file returned successfully", NULL);
#line 140 "moonshot-settings.c"
			_g_object_unref0 (_tmp5_);
		} else {
			MoonshotLogger* _tmp6_;
#line 56 "moonshot-settings.vala"
			moonshot_logger_trace (_tmp6_ = logger (), "get_keyfile: load_from_file returned false", NULL);
#line 146 "moonshot-settings.c"
			_g_object_unref0 (_tmp6_);
		}
	}
	goto __finally10;
	__catch10_g_file_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			MoonshotLogger* _tmp7_;
			char* _tmp8_;
#line 59 "moonshot-settings.vala"
			moonshot_logger_trace (_tmp7_ = logger (), _tmp8_ = g_strconcat ("get_keyfile: FileError: ", e->message, NULL), NULL);
#line 161 "moonshot-settings.c"
			_g_free0 (_tmp8_);
			_g_object_unref0 (_tmp7_);
			_g_error_free0 (e);
		}
	}
	goto __finally10;
	__catch10_g_key_file_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			MoonshotLogger* _tmp9_;
			char* _tmp10_;
#line 62 "moonshot-settings.vala"
			moonshot_logger_trace (_tmp9_ = logger (), _tmp10_ = g_strconcat ("get_keyfile: KeyFileError: ", e->message, NULL), NULL);
#line 178 "moonshot-settings.c"
			_g_free0 (_tmp10_);
			_g_object_unref0 (_tmp9_);
			_g_error_free0 (e);
		}
	}
	__finally10:
	if (_inner_error_ != NULL) {
		_g_free0 (path);
		_g_object_unref0 (dir);
		_g_free0 (config_dir);
		_g_key_file_free0 (key_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = key_file;
	_g_free0 (path);
	_g_object_unref0 (dir);
	_g_free0 (config_dir);
#line 65 "moonshot-settings.vala"
	return result;
#line 200 "moonshot-settings.c"
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, (gssize) (-1));
#line 1194 "glib-2.0.vapi"
	return result;
#line 210 "moonshot-settings.c"
}


#line 69 "moonshot-settings.vala"
void save_keyfile (GKeyFile* key_file) {
#line 216 "moonshot-settings.c"
	char* config_dir;
	GFile* dest;
	char* data;
	GError * _inner_error_ = NULL;
#line 69 "moonshot-settings.vala"
	g_return_if_fail (key_file != NULL);
#line 71 "moonshot-settings.vala"
	config_dir = g_strdup (g_get_user_config_dir ());
#line 72 "moonshot-settings.vala"
	dest = NULL;
#line 227 "moonshot-settings.c"
	{
		GFile* dir;
		GFile* _tmp0_;
#line 76 "moonshot-settings.vala"
		dir = g_file_new_for_path (config_dir);
#line 77 "moonshot-settings.vala"
		dest = (_tmp0_ = g_file_get_child (dir, KEY_FILE_NAME), _g_object_unref0 (dest), _tmp0_);
#line 78 "moonshot-settings.vala"
		g_file_make_directory_with_parents (dir, NULL, &_inner_error_);
#line 237 "moonshot-settings.c"
		if (_inner_error_ != NULL) {
			_g_object_unref0 (dir);
			goto __catch11_g_error;
		}
		_g_object_unref0 (dir);
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			MoonshotLogger* _tmp1_;
			char* _tmp2_;
#line 80 "moonshot-settings.vala"
			moonshot_logger_trace (_tmp1_ = logger (), _tmp2_ = g_strconcat ("save_keyfile: make_directory_with_parents threw error (this is usually" \
" ignorable) : ", e->message, NULL), NULL);
#line 255 "moonshot-settings.c"
			_g_free0 (_tmp2_);
			_g_object_unref0 (_tmp1_);
			_g_error_free0 (e);
		}
	}
	__finally11:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (dest);
		_g_free0 (config_dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
#line 87 "moonshot-settings.vala"
	data = g_key_file_to_data (key_file, NULL, NULL);
#line 271 "moonshot-settings.c"
	{
		MoonshotLogger* _tmp3_;
		char* _tmp4_;
		char* _tmp5_;
		char* new_etag;
		char* _tmp6_ = NULL;
		char* _tmp7_;
#line 89 "moonshot-settings.vala"
		moonshot_logger_trace (_tmp3_ = logger (), _tmp5_ = g_strdup_printf ("save_keyfile: saving to file path '%s'", _tmp4_ = g_file_get_path (dest)), NULL);
#line 281 "moonshot-settings.c"
		_g_free0 (_tmp5_);
		_g_free0 (_tmp4_);
		_g_object_unref0 (_tmp3_);
		new_etag = NULL;
#line 94 "moonshot-settings.vala"
		g_file_replace_contents (dest, data, (gsize) string_get_length (data), NULL, FALSE, G_FILE_CREATE_REPLACE_DESTINATION | G_FILE_CREATE_PRIVATE, &_tmp6_, NULL, &_inner_error_);
#line 94 "moonshot-settings.vala"
		new_etag = (_tmp7_ = _tmp6_, _g_free0 (new_etag), _tmp7_);
#line 290 "moonshot-settings.c"
		if (_inner_error_ != NULL) {
			_g_free0 (new_etag);
			goto __catch12_g_error;
		}
		_g_free0 (new_etag);
	}
	goto __finally12;
	__catch12_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			MoonshotLogger* _tmp8_;
			char* _tmp9_;
#line 97 "moonshot-settings.vala"
			moonshot_logger_error (_tmp8_ = logger (), _tmp9_ = g_strconcat ("save_keyfile: error when writing to file: ", e->message, NULL), NULL);
#line 308 "moonshot-settings.c"
			_g_free0 (_tmp9_);
			_g_object_unref0 (_tmp8_);
			_g_error_free0 (e);
		}
	}
	__finally12:
	if (_inner_error_ != NULL) {
		_g_free0 (data);
		_g_object_unref0 (dest);
		_g_free0 (config_dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_free0 (data);
	_g_object_unref0 (dest);
	_g_free0 (config_dir);
}


#line 103 "moonshot-settings.vala"
void set_bool_setting (const char* group_name, const char* key_name, gboolean value, GKeyFile* key_file) {
#line 331 "moonshot-settings.c"
	GKeyFile* tmp_key_file;
#line 103 "moonshot-settings.vala"
	g_return_if_fail (group_name != NULL);
#line 103 "moonshot-settings.vala"
	g_return_if_fail (key_name != NULL);
#line 105 "moonshot-settings.vala"
	tmp_key_file = NULL;
#line 106 "moonshot-settings.vala"
	if (key_file == NULL) {
#line 341 "moonshot-settings.c"
		GKeyFile* _tmp0_;
#line 108 "moonshot-settings.vala"
		tmp_key_file = (_tmp0_ = get_keyfile (), _g_key_file_free0 (tmp_key_file), _tmp0_);
#line 109 "moonshot-settings.vala"
		key_file = tmp_key_file;
#line 347 "moonshot-settings.c"
	}
#line 112 "moonshot-settings.vala"
	g_key_file_set_boolean (key_file, group_name, key_name, value);
#line 114 "moonshot-settings.vala"
	if (tmp_key_file != NULL) {
#line 116 "moonshot-settings.vala"
		save_keyfile (key_file);
#line 355 "moonshot-settings.c"
	}
	_g_key_file_free0 (tmp_key_file);
}


#line 1212 "glib-2.0.vapi"
static const char* string_to_string (const char* self) {
#line 363 "moonshot-settings.c"
	const char* result = NULL;
#line 1212 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 367 "moonshot-settings.c"
	result = self;
#line 1213 "glib-2.0.vapi"
	return result;
#line 371 "moonshot-settings.c"
}


#line 120 "moonshot-settings.vala"
gboolean get_bool_setting (const char* group_name, const char* key_name, gboolean _default_, GKeyFile* key_file) {
#line 377 "moonshot-settings.c"
	gboolean result = FALSE;
	GKeyFile* tmp_key_file;
	GError * _inner_error_ = NULL;
#line 120 "moonshot-settings.vala"
	g_return_val_if_fail (group_name != NULL, FALSE);
#line 120 "moonshot-settings.vala"
	g_return_val_if_fail (key_name != NULL, FALSE);
#line 122 "moonshot-settings.vala"
	tmp_key_file = NULL;
#line 123 "moonshot-settings.vala"
	if (key_file == NULL) {
#line 389 "moonshot-settings.c"
		GKeyFile* _tmp0_;
#line 125 "moonshot-settings.vala"
		tmp_key_file = (_tmp0_ = get_keyfile (), _g_key_file_free0 (tmp_key_file), _tmp0_);
#line 126 "moonshot-settings.vala"
		key_file = tmp_key_file;
#line 395 "moonshot-settings.c"
	}
#line 129 "moonshot-settings.vala"
	if (key_file == NULL) {
#line 399 "moonshot-settings.c"
		result = _default_;
		_g_key_file_free0 (tmp_key_file);
#line 130 "moonshot-settings.vala"
		return result;
#line 404 "moonshot-settings.c"
	}
	{
		gboolean _tmp1_;
#line 133 "moonshot-settings.vala"
		_tmp1_ = g_key_file_has_key (key_file, group_name, key_name, &_inner_error_);
#line 410 "moonshot-settings.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch13_g_key_file_error;
			}
			_g_key_file_free0 (tmp_key_file);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
#line 133 "moonshot-settings.vala"
		if (!_tmp1_) {
#line 422 "moonshot-settings.c"
			MoonshotLogger* _tmp2_;
			char* _tmp3_;
#line 135 "moonshot-settings.vala"
			moonshot_logger_info (_tmp2_ = logger (), _tmp3_ = g_strconcat ("get_bool_setting : key file doesn't contain key '", string_to_string (key_name), "' in group '", string_to_string (group_name), "'", NULL), NULL);
#line 427 "moonshot-settings.c"
			_g_free0 (_tmp3_);
			_g_object_unref0 (_tmp2_);
			result = _default_;
			_g_key_file_free0 (tmp_key_file);
#line 136 "moonshot-settings.vala"
			return result;
#line 434 "moonshot-settings.c"
		}
	}
	goto __finally13;
	__catch13_g_key_file_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			MoonshotLogger* _tmp4_;
			char* _tmp5_;
			char* _tmp6_;
#line 140 "moonshot-settings.vala"
			moonshot_logger_info (_tmp4_ = logger (), _tmp6_ = g_strconcat (_tmp5_ = g_strconcat ("get_bool_setting : KeyFileError checking if key '", string_to_string (key_name), "' exists in group '", string_to_string (group_name), "' (maybe ignorable?) : ", NULL), e->message, NULL), NULL);
#line 449 "moonshot-settings.c"
			_g_free0 (_tmp6_);
			_g_free0 (_tmp5_);
			_g_object_unref0 (_tmp4_);
			_g_error_free0 (e);
		}
	}
	__finally13:
	if (_inner_error_ != NULL) {
		_g_key_file_free0 (tmp_key_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	{
		gboolean _tmp7_;
#line 145 "moonshot-settings.vala"
		_tmp7_ = g_key_file_get_boolean (key_file, group_name, key_name, &_inner_error_);
#line 467 "moonshot-settings.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch14_g_key_file_error;
			}
			_g_key_file_free0 (tmp_key_file);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		result = _tmp7_;
		_g_key_file_free0 (tmp_key_file);
#line 145 "moonshot-settings.vala"
		return result;
#line 481 "moonshot-settings.c"
	}
	goto __finally14;
	__catch14_g_key_file_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			MoonshotLogger* _tmp8_;
			char* _tmp9_;
#line 148 "moonshot-settings.vala"
			moonshot_logger_info (_tmp8_ = logger (), _tmp9_ = g_strconcat ("get_bool_setting got KeyFileError (may be ignorable) : ", e->message, NULL), NULL);
#line 494 "moonshot-settings.c"
			_g_free0 (_tmp9_);
			_g_object_unref0 (_tmp8_);
			_g_error_free0 (e);
		}
	}
	__finally14:
	if (_inner_error_ != NULL) {
		_g_key_file_free0 (tmp_key_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = _default_;
	_g_key_file_free0 (tmp_key_file);
#line 150 "moonshot-settings.vala"
	return result;
#line 511 "moonshot-settings.c"
}


#line 154 "moonshot-settings.vala"
void set_string_setting (const char* group_name, const char* key_name, const char* value, GKeyFile* key_file) {
#line 517 "moonshot-settings.c"
	GKeyFile* tmp_key_file;
#line 154 "moonshot-settings.vala"
	g_return_if_fail (group_name != NULL);
#line 154 "moonshot-settings.vala"
	g_return_if_fail (key_name != NULL);
#line 154 "moonshot-settings.vala"
	g_return_if_fail (value != NULL);
#line 156 "moonshot-settings.vala"
	tmp_key_file = NULL;
#line 157 "moonshot-settings.vala"
	if (key_file == NULL) {
#line 529 "moonshot-settings.c"
		GKeyFile* _tmp0_;
#line 159 "moonshot-settings.vala"
		tmp_key_file = (_tmp0_ = get_keyfile (), _g_key_file_free0 (tmp_key_file), _tmp0_);
#line 160 "moonshot-settings.vala"
		key_file = tmp_key_file;
#line 535 "moonshot-settings.c"
	}
#line 163 "moonshot-settings.vala"
	g_key_file_set_string (key_file, group_name, key_name, value);
#line 164 "moonshot-settings.vala"
	if (tmp_key_file != NULL) {
#line 166 "moonshot-settings.vala"
		save_keyfile (key_file);
#line 543 "moonshot-settings.c"
	}
	_g_key_file_free0 (tmp_key_file);
}


#line 170 "moonshot-settings.vala"
char* get_string_setting (const char* group_name, const char* key_name, const char* _default_, GKeyFile* key_file) {
#line 551 "moonshot-settings.c"
	char* result = NULL;
	GKeyFile* tmp_key_file;
	GError * _inner_error_ = NULL;
#line 170 "moonshot-settings.vala"
	g_return_val_if_fail (group_name != NULL, NULL);
#line 170 "moonshot-settings.vala"
	g_return_val_if_fail (key_name != NULL, NULL);
#line 170 "moonshot-settings.vala"
	g_return_val_if_fail (_default_ != NULL, NULL);
#line 172 "moonshot-settings.vala"
	tmp_key_file = NULL;
#line 173 "moonshot-settings.vala"
	if (key_file == NULL) {
#line 565 "moonshot-settings.c"
		GKeyFile* _tmp0_;
#line 175 "moonshot-settings.vala"
		tmp_key_file = (_tmp0_ = get_keyfile (), _g_key_file_free0 (tmp_key_file), _tmp0_);
#line 176 "moonshot-settings.vala"
		key_file = tmp_key_file;
#line 571 "moonshot-settings.c"
	}
#line 179 "moonshot-settings.vala"
	if (key_file == NULL) {
#line 575 "moonshot-settings.c"
		result = g_strdup (_default_);
		_g_key_file_free0 (tmp_key_file);
#line 180 "moonshot-settings.vala"
		return result;
#line 580 "moonshot-settings.c"
	}
	{
		gboolean _tmp1_;
#line 183 "moonshot-settings.vala"
		_tmp1_ = g_key_file_has_key (key_file, group_name, key_name, &_inner_error_);
#line 586 "moonshot-settings.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch15_g_key_file_error;
			}
			_g_key_file_free0 (tmp_key_file);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
#line 183 "moonshot-settings.vala"
		if (!_tmp1_) {
#line 598 "moonshot-settings.c"
			MoonshotLogger* _tmp2_;
			char* _tmp3_;
#line 185 "moonshot-settings.vala"
			moonshot_logger_info (_tmp2_ = logger (), _tmp3_ = g_strconcat ("get_string_setting : key file doesn't contain key '", string_to_string (key_name), "' in group '", string_to_string (group_name), "'", NULL), NULL);
#line 603 "moonshot-settings.c"
			_g_free0 (_tmp3_);
			_g_object_unref0 (_tmp2_);
			result = g_strdup (_default_);
			_g_key_file_free0 (tmp_key_file);
#line 186 "moonshot-settings.vala"
			return result;
#line 610 "moonshot-settings.c"
		}
	}
	goto __finally15;
	__catch15_g_key_file_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			MoonshotLogger* _tmp4_;
			char* _tmp5_;
			char* _tmp6_;
#line 190 "moonshot-settings.vala"
			moonshot_logger_info (_tmp4_ = logger (), _tmp6_ = g_strconcat (_tmp5_ = g_strconcat ("get_string_setting : KeyFileError checking if key '", string_to_string (key_name), "' exists in group '", string_to_string (group_name), "' (maybe ignorable?) : ", NULL), e->message, NULL), NULL);
#line 625 "moonshot-settings.c"
			_g_free0 (_tmp6_);
			_g_free0 (_tmp5_);
			_g_object_unref0 (_tmp4_);
			_g_error_free0 (e);
		}
	}
	__finally15:
	if (_inner_error_ != NULL) {
		_g_key_file_free0 (tmp_key_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	{
		char* _tmp7_;
#line 195 "moonshot-settings.vala"
		_tmp7_ = g_key_file_get_string (key_file, group_name, key_name, &_inner_error_);
#line 643 "moonshot-settings.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_KEY_FILE_ERROR) {
				goto __catch16_g_key_file_error;
			}
			_g_key_file_free0 (tmp_key_file);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = _tmp7_;
		_g_key_file_free0 (tmp_key_file);
#line 195 "moonshot-settings.vala"
		return result;
#line 657 "moonshot-settings.c"
	}
	goto __finally16;
	__catch16_g_key_file_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			MoonshotLogger* _tmp8_;
			char* _tmp9_;
#line 198 "moonshot-settings.vala"
			moonshot_logger_info (_tmp8_ = logger (), _tmp9_ = g_strconcat ("get_string_setting got KeyFileError (may be ignorable) : ", e->message, NULL), NULL);
#line 670 "moonshot-settings.c"
			_g_free0 (_tmp9_);
			_g_object_unref0 (_tmp8_);
			_g_error_free0 (e);
		}
	}
	__finally16:
	if (_inner_error_ != NULL) {
		_g_key_file_free0 (tmp_key_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = g_strdup (_default_);
	_g_key_file_free0 (tmp_key_file);
#line 200 "moonshot-settings.vala"
	return result;
#line 687 "moonshot-settings.c"
}




