/* moonshot-utils.c generated by valac 0.10.4, the Vala compiler
 * generated from moonshot-utils.vala, do not modify */

/*
 * Copyright (c) 2011-2016, JANET(UK)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of JANET(UK) nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <stdio.h>
#include <gdk/gdk.h>
#include <atk/atk.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>


#define TYPE_ID_CARD (id_card_get_type ())
#define ID_CARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ID_CARD, IdCard))
#define ID_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ID_CARD, IdCardClass))
#define IS_ID_CARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ID_CARD))
#define IS_ID_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ID_CARD))
#define ID_CARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ID_CARD, IdCardClass))

typedef struct _IdCard IdCard;
typedef struct _IdCardClass IdCardClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _pango_font_description_free0(var) ((var == NULL) ? NULL : (var = (pango_font_description_free (var), NULL)))


extern gboolean gtk_available;
gboolean gtk_available = FALSE;
extern GdkColor white;
GdkColor white = {0};

GdkPixbuf* find_icon_sized (const char* name, GtkIconSize icon_size);
GdkPixbuf* find_icon (const char* name, gint size);
GType id_card_get_type (void) G_GNUC_CONST;
GdkPixbuf* get_pixbuf (IdCard* id);
const char* GetUserName (void);
const char* GetFlatStoreUsersFilePath (void);
gboolean UserForcesFlatFileStore (void);
void make_color (guint16 red, guint16 green, guint16 blue, GdkColor* result);
void set_atk_relation (GtkWidget* widget, GtkWidget* target_widget, AtkRelationType relationship);
GtkWidget* make_ta_fingerprint_widget (const char* server_cert, const char* label_text);
char* colonize (const char* input, gint bytes_per_line);
void clear_password_entry (GtkEntry* entry);
void set_bg_color (GtkWidget* w);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static int _vala_strcmp0 (const char * str1, const char * str2);



#line 40 "moonshot-utils.vala"
GdkPixbuf* find_icon_sized (const char* name, GtkIconSize icon_size) {
#line 95 "moonshot-utils.c"
	GdkPixbuf* result = NULL;
	gint width = 0;
	gint height = 0;
#line 40 "moonshot-utils.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 43 "moonshot-utils.vala"
	gtk_icon_size_lookup (icon_size, &width, &height);
#line 103 "moonshot-utils.c"
	result = find_icon (name, width);
#line 44 "moonshot-utils.vala"
	return result;
#line 107 "moonshot-utils.c"
}


#line 54 "moonshot-utils.vala"
GdkPixbuf* get_pixbuf (IdCard* id) {
#line 113 "moonshot-utils.c"
	GdkPixbuf* result = NULL;
#line 54 "moonshot-utils.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 117 "moonshot-utils.c"
	result = find_icon ("avatar-default", 48);
#line 56 "moonshot-utils.vala"
	return result;
#line 121 "moonshot-utils.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 59 "moonshot-utils.vala"
GdkPixbuf* find_icon (const char* name, gint size) {
#line 132 "moonshot-utils.c"
	GdkPixbuf* result = NULL;
	GError * _inner_error_ = NULL;
#line 59 "moonshot-utils.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 61 "moonshot-utils.vala"
	if (!gtk_available) {
#line 139 "moonshot-utils.c"
		result = NULL;
#line 62 "moonshot-utils.vala"
		return result;
#line 143 "moonshot-utils.c"
	}
	{
		GtkIconTheme* icon_theme;
		GdkPixbuf* _tmp0_;
#line 77 "moonshot-utils.vala"
		icon_theme = _g_object_ref0 (gtk_icon_theme_get_default ());
#line 78 "moonshot-utils.vala"
		_tmp0_ = gtk_icon_theme_load_icon (icon_theme, name, size, GTK_ICON_LOOKUP_FORCE_SIZE, &_inner_error_);
#line 152 "moonshot-utils.c"
		if (_inner_error_ != NULL) {
			_g_object_unref0 (icon_theme);
			goto __catch19_g_error;
		}
		result = _tmp0_;
		_g_object_unref0 (icon_theme);
#line 78 "moonshot-utils.vala"
		return result;
#line 161 "moonshot-utils.c"
	}
	goto __finally19;
	__catch19_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 83 "moonshot-utils.vala"
			fprintf (stdout, "Error loading icon '%s': %s\n", name, e->message);
#line 172 "moonshot-utils.c"
			result = NULL;
			_g_error_free0 (e);
#line 84 "moonshot-utils.vala"
			return result;
#line 177 "moonshot-utils.c"
		}
	}
	__finally19:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


#line 2847 "glib-2.0.vapi"
static char* g_file_stream_read_line (FILE* self) {
#line 191 "moonshot-utils.c"
	char* result = NULL;
	gint c = 0;
	GString* ret;
#line 2847 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 2849 "glib-2.0.vapi"
	ret = NULL;
#line 2850 "glib-2.0.vapi"
	while (TRUE) {
#line 2850 "glib-2.0.vapi"
		if (!((c = fgetc (self)) != EOF)) {
#line 2850 "glib-2.0.vapi"
			break;
#line 205 "moonshot-utils.c"
		}
#line 2851 "glib-2.0.vapi"
		if (ret == NULL) {
#line 209 "moonshot-utils.c"
			GString* _tmp0_;
#line 2852 "glib-2.0.vapi"
			ret = (_tmp0_ = g_string_new (""), _g_string_free0 (ret), _tmp0_);
#line 213 "moonshot-utils.c"
		}
#line 2854 "glib-2.0.vapi"
		if (c == '\n') {
#line 2855 "glib-2.0.vapi"
			break;
#line 219 "moonshot-utils.c"
		}
#line 2857 "glib-2.0.vapi"
		g_string_append_c (ret, (gchar) c);
#line 223 "moonshot-utils.c"
	}
#line 2859 "glib-2.0.vapi"
	if (ret == NULL) {
#line 227 "moonshot-utils.c"
		result = NULL;
		_g_string_free0 (ret);
#line 2860 "glib-2.0.vapi"
		return result;
#line 232 "moonshot-utils.c"
	} else {
		result = g_strdup (ret->str);
		_g_string_free0 (ret);
#line 2862 "glib-2.0.vapi"
		return result;
#line 238 "moonshot-utils.c"
	}
	_g_string_free0 (ret);
}


#line 91 "moonshot-utils.vala"
gboolean UserForcesFlatFileStore (void) {
#line 246 "moonshot-utils.c"
	gboolean result = FALSE;
	char* username;
	char* flatstore_users_filename;
	FILE* flatstore_users;
	char* flatstore_username;
#line 93 "moonshot-utils.vala"
	username = g_strdup (GetUserName ());
#line 94 "moonshot-utils.vala"
	flatstore_users_filename = g_strdup (GetFlatStoreUsersFilePath ());
#line 95 "moonshot-utils.vala"
	flatstore_users = fopen (flatstore_users_filename, "r");
#line 96 "moonshot-utils.vala"
	if (flatstore_users == NULL) {
#line 260 "moonshot-utils.c"
		result = FALSE;
		_fclose0 (flatstore_users);
		_g_free0 (flatstore_users_filename);
		_g_free0 (username);
#line 97 "moonshot-utils.vala"
		return result;
#line 267 "moonshot-utils.c"
	}
#line 99 "moonshot-utils.vala"
	flatstore_username = NULL;
#line 100 "moonshot-utils.vala"
	while (TRUE) {
#line 273 "moonshot-utils.c"
		char* _tmp0_;
#line 100 "moonshot-utils.vala"
		if (!((flatstore_username = (_tmp0_ = g_file_stream_read_line (flatstore_users), _g_free0 (flatstore_username), _tmp0_)) != NULL)) {
#line 100 "moonshot-utils.vala"
			break;
#line 279 "moonshot-utils.c"
		}
#line 101 "moonshot-utils.vala"
		if (_vala_strcmp0 (username, flatstore_username) == 0) {
#line 283 "moonshot-utils.c"
			result = TRUE;
			_g_free0 (flatstore_username);
			_fclose0 (flatstore_users);
			_g_free0 (flatstore_users_filename);
			_g_free0 (username);
#line 102 "moonshot-utils.vala"
			return result;
#line 291 "moonshot-utils.c"
		}
	}
	result = FALSE;
	_g_free0 (flatstore_username);
	_fclose0 (flatstore_users);
	_g_free0 (flatstore_users_filename);
	_g_free0 (username);
#line 105 "moonshot-utils.vala"
	return result;
#line 301 "moonshot-utils.c"
}


#line 108 "moonshot-utils.vala"
void make_color (guint16 red, guint16 green, guint16 blue, GdkColor* result) {
#line 307 "moonshot-utils.c"
	GdkColor color = {0};
	memset (&color, 0, sizeof (GdkColor));
#line 111 "moonshot-utils.vala"
	color.red = red;
#line 112 "moonshot-utils.vala"
	color.green = green;
#line 113 "moonshot-utils.vala"
	color.blue = blue;
#line 316 "moonshot-utils.c"
	*result = color;
#line 115 "moonshot-utils.vala"
	return;
#line 320 "moonshot-utils.c"
}


#line 118 "moonshot-utils.vala"
void set_atk_relation (GtkWidget* widget, GtkWidget* target_widget, AtkRelationType relationship) {
#line 326 "moonshot-utils.c"
	AtkObject* atk_widget;
	AtkObject* atk_target_widget;
#line 118 "moonshot-utils.vala"
	g_return_if_fail (widget != NULL);
#line 118 "moonshot-utils.vala"
	g_return_if_fail (target_widget != NULL);
#line 120 "moonshot-utils.vala"
	atk_widget = _g_object_ref0 (gtk_widget_get_accessible (widget));
#line 121 "moonshot-utils.vala"
	atk_target_widget = _g_object_ref0 (gtk_widget_get_accessible (target_widget));
#line 123 "moonshot-utils.vala"
	atk_object_add_relationship (atk_widget, relationship, atk_target_widget);
#line 339 "moonshot-utils.c"
	_g_object_unref0 (atk_target_widget);
	_g_object_unref0 (atk_widget);
}


#line 127 "moonshot-utils.vala"
GtkWidget* make_ta_fingerprint_widget (const char* server_cert, const char* label_text) {
#line 347 "moonshot-utils.c"
	GtkWidget* result = NULL;
	char* _tmp0_;
	GtkLabel* fingerprint_label;
	GtkTextView* fingerprint;
	PangoFontDescription* fontdesc;
	GtkTextBuffer* buffer;
	char* _tmp2_;
	GtkScrolledWindow* fingerprint_width_constraint;
	GtkVBox* vbox;
#line 127 "moonshot-utils.vala"
	g_return_val_if_fail (server_cert != NULL, NULL);
#line 129 "moonshot-utils.vala"
	_tmp0_ = g_strdup (label_text);
#line 129 "moonshot-utils.vala"
	if (_tmp0_ == NULL) {
#line 363 "moonshot-utils.c"
		char* _tmp1_;
#line 129 "moonshot-utils.vala"
		_tmp0_ = (_tmp1_ = g_strdup (_ ("SHA-256 fingerprint:")), _g_free0 (_tmp0_), _tmp1_);
#line 367 "moonshot-utils.c"
	}
#line 129 "moonshot-utils.vala"
	fingerprint_label = g_object_ref_sink ((GtkLabel*) gtk_label_new (_tmp0_));
#line 130 "moonshot-utils.vala"
	gtk_misc_set_alignment ((GtkMisc*) fingerprint_label, (float) 0, 0.5f);
#line 132 "moonshot-utils.vala"
	fingerprint = g_object_ref_sink ((GtkTextView*) gtk_text_view_new ());
#line 133 "moonshot-utils.vala"
	fontdesc = pango_font_description_from_string ("monospace 10");
#line 134 "moonshot-utils.vala"
	gtk_widget_modify_font ((GtkWidget*) fingerprint, fontdesc);
#line 135 "moonshot-utils.vala"
	gtk_text_view_set_editable (fingerprint, FALSE);
#line 136 "moonshot-utils.vala"
	gtk_text_view_set_left_margin (fingerprint, 3);
#line 137 "moonshot-utils.vala"
	buffer = _g_object_ref0 (gtk_text_view_get_buffer (fingerprint));
#line 138 "moonshot-utils.vala"
	gtk_text_buffer_set_text (buffer, _tmp2_ = colonize (server_cert, 16), -1);
#line 387 "moonshot-utils.c"
	_g_free0 (_tmp2_);
#line 139 "moonshot-utils.vala"
	gtk_text_view_set_wrap_mode (fingerprint, GTK_WRAP_WORD_CHAR);
#line 141 "moonshot-utils.vala"
	set_atk_relation ((GtkWidget*) fingerprint_label, (GtkWidget*) fingerprint, ATK_RELATION_LABEL_FOR);
#line 143 "moonshot-utils.vala"
	fingerprint_width_constraint = g_object_ref_sink ((GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL));
#line 144 "moonshot-utils.vala"
	gtk_scrolled_window_set_policy (fingerprint_width_constraint, GTK_POLICY_NEVER, GTK_POLICY_NEVER);
#line 145 "moonshot-utils.vala"
	gtk_scrolled_window_set_shadow_type (fingerprint_width_constraint, GTK_SHADOW_IN);
#line 146 "moonshot-utils.vala"
	gtk_widget_set_size_request ((GtkWidget*) fingerprint_width_constraint, 360, 60);
#line 147 "moonshot-utils.vala"
	gtk_scrolled_window_add_with_viewport (fingerprint_width_constraint, (GtkWidget*) fingerprint);
#line 149 "moonshot-utils.vala"
	vbox = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0));
#line 150 "moonshot-utils.vala"
	gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) fingerprint_label, TRUE, TRUE, (guint) 2);
#line 151 "moonshot-utils.vala"
	gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) fingerprint_width_constraint, TRUE, TRUE, (guint) 2);
#line 409 "moonshot-utils.c"
	result = (GtkWidget*) vbox;
	_g_object_unref0 (fingerprint_width_constraint);
	_g_object_unref0 (buffer);
	_pango_font_description_free0 (fontdesc);
	_g_object_unref0 (fingerprint);
	_g_object_unref0 (fingerprint_label);
	_g_free0 (_tmp0_);
#line 152 "moonshot-utils.vala"
	return result;
#line 419 "moonshot-utils.c"
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, (gssize) (-1));
#line 1194 "glib-2.0.vapi"
	return result;
#line 429 "moonshot-utils.c"
}


#line 1126 "glib-2.0.vapi"
static char* string_slice (const char* self, glong start, glong end) {
#line 435 "moonshot-utils.c"
	char* result = NULL;
	glong string_length;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const char* start_string;
#line 1126 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1127 "glib-2.0.vapi"
	string_length = string_get_length (self);
#line 1128 "glib-2.0.vapi"
	if (start < 0) {
#line 1129 "glib-2.0.vapi"
		start = string_length + start;
#line 449 "moonshot-utils.c"
	}
#line 1131 "glib-2.0.vapi"
	if (end < 0) {
#line 1132 "glib-2.0.vapi"
		end = string_length + end;
#line 455 "moonshot-utils.c"
	}
#line 1134 "glib-2.0.vapi"
	if (start >= 0) {
#line 1134 "glib-2.0.vapi"
		_tmp0_ = start <= string_length;
#line 461 "moonshot-utils.c"
	} else {
#line 1134 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 465 "moonshot-utils.c"
	}
#line 1134 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp0_, NULL);
#line 1135 "glib-2.0.vapi"
	if (end >= 0) {
#line 1135 "glib-2.0.vapi"
		_tmp1_ = end <= string_length;
#line 473 "moonshot-utils.c"
	} else {
#line 1135 "glib-2.0.vapi"
		_tmp1_ = FALSE;
#line 477 "moonshot-utils.c"
	}
#line 1135 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp1_, NULL);
#line 1136 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1137 "glib-2.0.vapi"
	start_string = g_utf8_offset_to_pointer (self, start);
#line 485 "moonshot-utils.c"
	result = g_strndup (start_string, ((gchar*) g_utf8_offset_to_pointer (start_string, end - start)) - ((gchar*) start_string));
#line 1138 "glib-2.0.vapi"
	return result;
#line 489 "moonshot-utils.c"
}


#line 156 "moonshot-utils.vala"
char* colonize (const char* input, gint bytes_per_line) {
#line 495 "moonshot-utils.c"
	char* result = NULL;
	char* _result_;
	gint i;
	gint line_bytes;
#line 156 "moonshot-utils.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 157 "moonshot-utils.vala"
	g_return_if_fail ((string_get_length (input) % 2) == 0);
#line 159 "moonshot-utils.vala"
	_result_ = g_strdup ("");
#line 160 "moonshot-utils.vala"
	i = 0;
#line 161 "moonshot-utils.vala"
	line_bytes = 0;
#line 162 "moonshot-utils.vala"
	while (TRUE) {
#line 512 "moonshot-utils.c"
		char* _tmp2_;
		char* _tmp3_;
#line 162 "moonshot-utils.vala"
		if (!(i < string_get_length (input))) {
#line 162 "moonshot-utils.vala"
			break;
#line 519 "moonshot-utils.c"
		}
#line 163 "moonshot-utils.vala"
		if (line_bytes == bytes_per_line) {
#line 523 "moonshot-utils.c"
			char* _tmp0_;
#line 164 "moonshot-utils.vala"
			_result_ = (_tmp0_ = g_strconcat (_result_, "\n", NULL), _g_free0 (_result_), _tmp0_);
#line 165 "moonshot-utils.vala"
			line_bytes = 0;
#line 529 "moonshot-utils.c"
		} else {
#line 167 "moonshot-utils.vala"
			if (i > 0) {
#line 533 "moonshot-utils.c"
				char* _tmp1_;
#line 168 "moonshot-utils.vala"
				_result_ = (_tmp1_ = g_strconcat (_result_, ":", NULL), _g_free0 (_result_), _tmp1_);
#line 537 "moonshot-utils.c"
			}
		}
#line 170 "moonshot-utils.vala"
		_result_ = (_tmp3_ = g_strconcat (_result_, _tmp2_ = string_slice (input, (glong) i, (glong) (i + 2)), NULL), _g_free0 (_result_), _tmp3_);
#line 542 "moonshot-utils.c"
		_g_free0 (_tmp2_);
#line 171 "moonshot-utils.vala"
		i = i + 2;
#line 172 "moonshot-utils.vala"
		line_bytes++;
#line 548 "moonshot-utils.c"
	}
	result = _result_;
#line 174 "moonshot-utils.vala"
	return result;
#line 553 "moonshot-utils.c"
}


#line 177 "moonshot-utils.vala"
void clear_password_entry (GtkEntry* entry) {
#line 559 "moonshot-utils.c"
	glong len;
	gint random_chars_length1;
	gint _random_chars_size_;
	gchar* _tmp0_;
	gchar* random_chars;
	char* r;
	GtkEntryBuffer* buf;
	gint a_length1;
	gint _a_size_;
	char** _tmp2_;
	char** a;
	char* _tmp3_;
#line 177 "moonshot-utils.vala"
	g_return_if_fail (entry != NULL);
#line 180 "moonshot-utils.vala"
	len = string_get_length (gtk_entry_get_text (entry));
#line 576 "moonshot-utils.c"
	random_chars = (_tmp0_ = g_new0 (gchar, len + 1), random_chars_length1 = len + 1, _random_chars_size_ = random_chars_length1, _tmp0_);
	{
		gint i;
#line 182 "moonshot-utils.vala"
		i = 0;
#line 582 "moonshot-utils.c"
		{
			gboolean _tmp1_;
#line 182 "moonshot-utils.vala"
			_tmp1_ = TRUE;
#line 182 "moonshot-utils.vala"
			while (TRUE) {
#line 182 "moonshot-utils.vala"
				if (!_tmp1_) {
#line 182 "moonshot-utils.vala"
					i++;
#line 593 "moonshot-utils.c"
				}
#line 182 "moonshot-utils.vala"
				_tmp1_ = FALSE;
#line 182 "moonshot-utils.vala"
				if (!(i < len)) {
#line 182 "moonshot-utils.vala"
					break;
#line 601 "moonshot-utils.c"
				}
#line 183 "moonshot-utils.vala"
				random_chars[i] = (gchar) g_random_int_range ((gint32) 40, (gint32) 127);
#line 605 "moonshot-utils.c"
			}
		}
	}
#line 185 "moonshot-utils.vala"
	random_chars[len] = (gchar) 0;
#line 186 "moonshot-utils.vala"
	r = g_strdup ((const char*) random_chars);
#line 187 "moonshot-utils.vala"
	buf = _g_object_ref0 (gtk_entry_get_buffer (entry));
#line 615 "moonshot-utils.c"
	a = (_tmp2_ = g_new0 (char*, 1 + 1), a_length1 = 1, _a_size_ = a_length1, _tmp2_);
#line 196 "moonshot-utils.vala"
	a[0] = (_tmp3_ = g_strdup (r), _g_free0 (a[0]), _tmp3_);
#line 197 "moonshot-utils.vala"
	gtk_entry_buffer_set_text (buf, a, a_length1);
#line 200 "moonshot-utils.vala"
	gtk_entry_buffer_delete_text (buf, (guint) 0, (gint) len);
#line 623 "moonshot-utils.c"
	a = (_vala_array_free (a, a_length1, (GDestroyNotify) g_free), NULL);
	_g_object_unref0 (buf);
	_g_free0 (r);
	random_chars = (g_free (random_chars), NULL);
}


#line 205 "moonshot-utils.vala"
void set_bg_color (GtkWidget* w) {
#line 205 "moonshot-utils.vala"
	g_return_if_fail (w != NULL);
#line 635 "moonshot-utils.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




